/* mpTree 0.1.2
 * -----------[ http://mptree.netpedia.net
 *
 *   Use this software at your own risk!
 *    This software falls under the GPL.
 *   Read COPYING for further informations.
 */

#include "mptree.h"

void send_artist_to_list(GtkCTreeNode *artist, char target)
{
  GtkCTreeNode *album=NULL;
	
  if (!(album=GTK_CTREE_ROW(artist)->children)) return; 
  do {
    send_album_to_list(album, target);
  } while ((album=GTK_CTREE_ROW(album)->sibling));
}

void send_album_to_list(GtkCTreeNode *album, char target)
{
  GtkCTreeNode *song=NULL;

  if (!(song=GTK_CTREE_ROW(album)->children)) return; 
  do {
    if (target == GQMPEG)
      send_song_to_external_playlist(song);
    if (target == SONGLIST)
      add_songlist_item(song);
  } while ((song=GTK_CTREE_ROW(song)->sibling));
}
void send_song_to_external_playlist(GtkCTreeNode *song)
{
  FILE *fd;
  char *whole_path;

  whole_path = get_whole_path(song);
  if (whole_path) {
	fd = fopen (NAMED_PIPE, "wb");
	fputs("pladd \"", fd);
	fputs(whole_path, fd);
	fputs("\"\n", fd);
	fclose(fd);
  }
}

void clear_external_playlist()
{
  FILE *fd;

  fd = fopen (NAMED_PIPE, "wb");
  fputs("clear_pl", fd);
 // fputs("\n", fd);
  fclose(fd);
}
