/* mpTree 0.1.2
 * -----------[ http://mptree.netpedia.net
 *
 *   Use this software at your own risk!
 *    This software falls under the GPL.
 *   Read COPYING for further informations.
 */

#include "mptree.h"

GtkWidget *medianame, *mountpoint, *media_list;
gint selected_medialist_row=-1;

void create__medialist(GtkWidget * medialisttab)
{
   GtkWidget *scrollwin, *mainbox, *entrybox, *apply_button;
   char *text[] = { "Name", "Songs", "Size", "Length", "Location", };
  
   mainbox=gtk_vbox_new(FALSE, 3);
   gtk_container_add(GTK_CONTAINER(medialisttab), mainbox);

   entrybox=gtk_hbox_new(FALSE, 3);
   gtk_box_pack_start(GTK_BOX(mainbox), entrybox, FALSE, FALSE, TRUE);

   medianame=gtk_entry_new();
   mountpoint=gtk_combo_new();

   apply_button=gtk_button_new_with_label("Apply");
   gtk_signal_connect(GTK_OBJECT(apply_button),
                   "clicked",
                   GTK_SIGNAL_FUNC(medialist_apply_button_pressed),
                   NULL);


   gtk_box_pack_end(GTK_BOX(entrybox), apply_button, FALSE, FALSE, TRUE);
   gtk_box_pack_end(GTK_BOX(entrybox), mountpoint, TRUE, TRUE, TRUE);
   gtk_box_pack_end(GTK_BOX(entrybox), medianame, FALSE, TRUE, TRUE);

   scrollwin=gtk_scrolled_window_new(NULL, NULL);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(scrollwin), 
     GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
   gtk_box_pack_start(GTK_BOX(mainbox), scrollwin, TRUE, TRUE, TRUE);

   media_list=gtk_clist_new_with_titles(5, text);
   gtk_clist_set_column_auto_resize (GTK_CLIST(media_list), 0, TRUE);
   gtk_clist_set_column_auto_resize (GTK_CLIST(media_list), 1, TRUE);
   gtk_clist_set_column_auto_resize (GTK_CLIST(media_list), 2, TRUE);
   gtk_clist_set_column_auto_resize (GTK_CLIST(media_list), 3, TRUE);
   gtk_clist_set_column_auto_resize (GTK_CLIST(media_list), 4, TRUE);
   gtk_signal_connect(GTK_OBJECT( media_list),
                   "select_row",
                   GTK_SIGNAL_FUNC(medialist_item_selected),
                   NULL);
   gtk_container_add(GTK_CONTAINER(scrollwin), media_list);
}

void medialist_item_selected(GtkWidget *clist, gint row, gint column,GdkEventButton *event, gpointer data)
{
   char *text[1];

   selected_medialist_row=row;

   gtk_clist_get_text(GTK_CLIST(clist), row, 0, text);
   gtk_entry_set_text(GTK_ENTRY(medianame), text[0]);

   gtk_clist_get_text(GTK_CLIST(clist), row, 4, text);
   gtk_entry_set_text(GTK_ENTRY( GTK_COMBO(mountpoint) ->entry), text[0]);
   selected_medium = row;
}

int medialist_apply_button_pressed()
{
  char *text[1];
  char available=FALSE;

  if (selected_medialist_row<0) return(1);

  if (strcmp(get_media_path(selected_medialist_row), ""))
    available=TRUE;

  text[0]=gtk_entry_get_text(GTK_ENTRY(medianame));
  gtk_clist_set_text(GTK_CLIST(media_list), selected_medialist_row, 0, text[0]);

  text[0]=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(mountpoint)->entry));
  gtk_clist_set_text(GTK_CLIST(media_list), selected_medialist_row, 4, text[0]);

  if (strcmp(text[0], "") && !available)
  {
    if (!av_root)
    {
      text[0] = (char *) "Available mp3";
      av_root = gtk_ctree_insert_node(GTK_CTREE(ctree), NULL, NULL, text, 5,
				 GTK_PIXMAP(dbicon)->pixmap, NULL,
				 GTK_PIXMAP(dbicon)->pixmap, NULL,
				 FALSE, TRUE);

    }
    add_medium_to_node(GTK_CTREE(ctree), av_root, selected_medialist_row);
  } else if (!strcmp(text[0], "") && available) {
    remove_medium_from_node(GTK_CTREE(ctree), av_root, selected_medialist_row);
    if (!GTK_CTREE_ROW(av_root)->children) {
  	gtk_ctree_remove_node(GTK_CTREE(ctree), av_root);	
	av_root = NULL;
    }
  }
  return(0);
}

void add_medialist_item(char *text[6])
{
  gtk_clist_append(GTK_CLIST(media_list), text);
  gtk_widget_draw_focus(media_list);
}

char *get_media_name(int row)
{
  char *text[1];

  gtk_clist_get_text(GTK_CLIST(media_list), row, 0, text);
  return text[0];
}

char *get_media_path(int row)
{
  char *text[1];

  gtk_clist_get_text(GTK_CLIST(media_list), row, 4, text);
  return text[0]; 
}

char *get_media_length(int row)
{
  char *text[1];

  gtk_clist_get_text(GTK_CLIST(media_list), row, 3, text);

  return text[0];
}

short get_media_sc(int row)
{
  char *text[1];
  int ret;

  gtk_clist_get_text(GTK_CLIST(media_list), row, 1, text);

  sscanf(text[0], "%d", &ret);
  return (short) ret;
}

short get_media_size(int row)
{
  char *text[1];
  int ret;

  gtk_clist_get_text(GTK_CLIST(media_list), row, 2, text);

  sscanf(text[0], "%dMB", &ret);
  return (short) ret;
}

void clear_medialist()
{
  int i;

  gtk_widget_hide(media_list);
  gtk_widget_hide(ctree);
  if (av_root)
  {
    i=0;
    do {
      remove_medium_from_node(GTK_CTREE(ctree), av_root, i);
      if (!GTK_CTREE_ROW(av_root)->children) {
    	gtk_ctree_remove_node(GTK_CTREE(ctree), av_root);	
	av_root = NULL;
      }
      i++;
    } while ((i<=max_row_medialist) && av_root);
  }
  gtk_clist_clear(GTK_CLIST(media_list));
  gtk_widget_show(ctree);
  gtk_widget_show(media_list);
  max_row_medialist=-1;
  selected_medialist_row=-1;
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(mountpoint)->entry), "");
  gtk_entry_set_text(GTK_ENTRY(medianame), "");
}
