/* mpTree 0.1.2
 * -----------[ http://mptree.netpedia.net
 *
 *   Use this software at your own risk!
 *    This software falls under the GPL.
 *   Read COPYING for further informations.
 */

/*#include <gtk/gtk.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <dirent.h>
#include <string.h>*/

#include <pwd.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <dirent.h>

/*
 *-------------------------------------
 * includes for glib / gtk / imlib
 *-------------------------------------
 */

#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gdk_imlib.h>


#define SONGLIST 0
#define GQMPEG 1

typedef struct
{
  char *artist;		/*  just for soundtracks		*
			 *  itemtext: blabla [the persons]	*
			 *  artist would give "the persons]"	*
			 *  - just for saving memory :)		*/
  char *year;
  char *comment;
  char genre;
  char *filename;
  unsigned short onmedia;
  unsigned short s_length;	// songlength in seconds
  gboolean has_trackn;	// TRUE when song has got tracknumber
} additional_info;

typedef additional_info *apointer;

typedef struct _ID3_Data ID3_Data;
struct _ID3_Data
{
        gchar *title;
        gchar *artist;
        gchar *album;
        gchar *year;
        gchar *comment;
        gint8 genre;
        gchar *genre_description;
};

typedef struct _artist_list artist_list;
struct _artist_list
{
        char *artist;
	char songcount;

        artist_list *next;
};

typedef struct _dir_list dir_list;
struct _dir_list
{
	char *dirname;
	char songcount;
	
	artist_list *f_artist;		// the first artist in the list
	artist_list *mostSongs;		/* pointer to artist with
					 * most songs in list */
	dir_list *next;
};

	// globals.c variables & consts

extern GtkWidget *addfileswin, *statusbar, *box, *mainwin;
extern GtkWidget *writing_setup_widget, *writing_widget, *about_box;
extern GtkWidget *artisticon, *albumicon, *songicon, *dbicon;		// icons
GdkPixmap *artistpixmap, *albumpixmap, *songpixmap, *dbpixmap;
// GdkBitmap *songbitmap;
extern GtkWidget *ctree, *songList;
extern GtkWidget *pathentry, *mediumentry;
extern GtkCTreeNode *root, *sndt_root, *selected_tree_item, *av_root;

extern char *NO_ARTIST;
extern char *NO_ALBUM;
extern char *NO_TITLE;
extern char *SNDTRACKS;
extern char SORT_RECURSIVE;
extern char SORT_SNDTRACKS;
extern char *NAMED_PIPE;
extern float MAX_PERCENT;

extern unsigned short max_row_medialist, songlist_count;
extern char message[255];
extern float media_size;
extern unsigned int media_sl;
extern unsigned int selected_medium, selected_slitem;


        // mp3io.c routines

gchar* get_id3_genre(gint g);
ID3_Data *get_id3_tag(gchar *path);
gint set_id3_tag(gchar *path, gchar *title, gchar *artist, gchar *album,
                 gchar *year, gchar *comment, guint8 genre);
void free_id3_tag(ID3_Data *d);
int header_is_valid(unsigned char *hdr);
int song_length(char *path);

	// ctree.c routines
void create__tree(GtkWidget *treescrollwin);
unsigned int add_files_recursive(char *d, char *relroot, char media);
void sort_soundtracks(unsigned short media);
GtkCTreeNode *my_find_tree_node(GtkCTreeNode *node, char *text);
char *get_node_text(GtkCTreeNode *node);
char *get_title(GtkCTreeNode *song);
char *get_artist_by_node(GtkCTreeNode *song);
dir_list *get_dirlist_elem(dir_list *first, char *just_path);
artist_list *get_artistlist_elem(artist_list *first, char *artist);
char *get_jpath(char *filename);
void tree_item_selected(GtkWidget *tree, GtkWidget *node);
void tree_rightmouse_pressed(GtkWidget *widget, GdkEventButton *event);
void dhms_time(unsigned int tis, char *d, char *h, char *m, char *s);
void free_dirlist(dir_list *first);
unsigned int get_tracknumber(char *relpath);
void delete_db_item();
void delete_song(GtkCTree *tree, GtkCTreeNode *node, int *seconds, char free_ainfo);
int delete_album(GtkCTree *tree, GtkCTreeNode *node, int *seconds);
int delete_artist(GtkCTree *tree, GtkCTreeNode *node, int *seconds);
void add_medium_to_node(GtkCTree *tree, GtkCTreeNode *node, char medium);
void remove_medium_from_node(GtkCTree *tree, GtkCTreeNode *node, char medium);
GtkCTreeNode *add_song_to_tree(GtkCTree *tree, GtkCTreeNode *rnode, 
	char *artist, char *album, char *title, additional_info *ainfo);

	// list.c routines
void create__list(GtkWidget *list);
void add_songlist_item(GtkCTreeNode *node);
void songlist_row_selected(GtkCList *clist, gint row,
	gint column);
void songlist_rightmouse_pressed(GtkWidget *widget, GdkEventButton *event);
void sl_move_up();
unsigned int sum_sl_totaltime();
void sl_move_down();
void add_sl_to_epl();
void clear_sl();
void sl_remove_item();

	// medialist.c routines
void create__medialist(GtkWidget *medialist);
void medialist_item_selected(GtkWidget *clist, gint row, gint column,GdkEventButton *event, gpointer data);
int medialist_apply_button_pressed();
void add_medialist_item(char *text[5]);
char *get_media_name(int row);
char *get_media_path(int row);
short get_media_sc(int row);
short get_media_size(int row);
char *get_media_length(int row);
void clear_medialist();

	// toolbar.c routines
void create__toolbar();
void file_open_ok_pressed();
void open_database_button();
void file_save_ok_pressed();
void save_database_button();
void disable_tb_items(int notebookpage);
	
	// menubar.c routines
void create__menubar();
void to_songlist();
void add_to_external_playlist();
void add_files_to_tree_selected();
void add_files_cancel_pressed();
void add_files_ok_pressed();
void show_about_box();
void disable_mb_items(int notebookpage);

        // gqmpeg_comm.c routines
void send_artist_to_list(GtkCTreeNode *artist, char target);
void send_album_to_list(GtkCTreeNode *album, char target);
void send_song_to_external_playlist(GtkCTreeNode *song);
void clear_external_playlist();
	
	// database.c routines

void new_database();
void savedb(char *fileName);
void loaddb(char *fileName);
char *get_whole_path(GtkCTreeNode *song);
void get_statistics(GtkCTreeNode *node, char *medium, int *sc);

  	// mptree.c routines
int main(int argc, char *argv[]);
void create__symbols();
void notebook_page_switched(GtkNotebook *nb, GtkWidget *widget, int page);
void exit_appl();
